﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Convertor.Interface
{
    /// <summary>
    /// 插件内容（插件必须继承该接口）
    /// </summary>
    public interface IPluginInfo
    {
        /// <summary>
        /// 插件名称
        /// </summary>
        string Name { get; }
        /// <summary>
        /// 插件描述
        /// </summary>
        string Description { get; }
        /// <summary>
        /// 是否被选中
        /// </summary>
        bool IsSelected { get; set; }
        /// <summary>
        /// 顺序
        /// </summary>
        int Order { get; set; }
    }
}
