﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Convertor.Interface
{
    /// <summary>
    /// 插件副本接口（用于保存插件信息和插件子插件）
    /// </summary>
    public interface IPluginItem : IPluginInfo, IPluginConfig, IPluginPath
    {
        /// <summary>
        /// 子插件
        /// </summary>
        ObservableCollection<IPluginItem> ChildPlugins { get; set; }
        /// <summary>
        /// 母插件
        /// </summary>
        IPluginItem ParentPlugin { get; set; }
        /// <summary>
        /// 
        /// </summary>
        string UiqueId { get; }

    }
}
