﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using Convertor.Interface;
using Wpf.CommonTools.SystemExtension;
using Wpf.CommonTools.WebExtension;
using Wpf.CommonTools.StringExtension;

namespace Convertor.Plugin.Combin
{
    public enum CombineTypes
    {
        Connect,
        StringFormat
    }
    [Serializable]
    public class ConfigContent : IConfigContent, INotifyPropertyChanged, ISerializable, ICloneable
    {
        private string splitor = string.Empty;

        public string Splitor
        {
            get { return splitor; }
            set { splitor = value; if (PropertyChanged != null) { PropertyChanged(this, new PropertyChangedEventArgs("ToolTip")); } }
        }
        private CombineTypes combieType = CombineTypes.Connect;

        public CombineTypes CombineType
        {
            get { return combieType; }
            set { combieType = value; }
        }


        public ConfigContent()
        {
        }

        public override string ToString()
        {
            return ToolTip;
        }

        #region IToolTip 成员

        public string ToolTip
        {
            get
            {
                if (combieType == CombineTypes.StringFormat)
                {
                    return string.Format(UILanguage.FindResource("Plugin_Combin_FormatInfo"),
                        this.splitor.ToLimitLength(100));
                }
                else
                {
                    return string.Format(UILanguage.FindResource("Plugin_Combin_Info"),
                        this.splitor.ToLimitLength(100));
                }
            }
        }

        #endregion

        #region INotifyPropertyChanged 成员

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region ICloneable 成员

        public object Clone()
        {
            ConfigContent a = new ConfigContent()
            {
                Splitor = this.Splitor,
                CombineType = this.CombineType
            };
            return a;
        }

        #endregion

        #region ISerializable 成员

        public void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            info.AddValue("Splitor", Splitor, typeof(string));
            info.AddValue("CombineType", CombineType, typeof(CombineTypes));
        }

        public ConfigContent(SerializationInfo info, StreamingContext context)
        {
            // Reset the property value using the GetValue method.
            splitor = (string)info.GetValue("Splitor", typeof(string));
            try
            {
                CombineType = (CombineTypes)info.GetValue("CombineType", typeof(CombineTypes));
            }
            catch { }
        }

        #endregion

    }
}
