﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Security.Cryptography;
using System.IO;

namespace Convertor.Plugin.Encrypt
{
    public static class SymmetricMethod
    {    /// <summary>
        /// 加密解密
        /// </summary>

        private static SymmetricAlgorithm mobjCryptoService = new RijndaelManaged();
        private static string key = "jcsmkjGuz(%&hj7x89H$y";

        public static string Key
        {
            get { return SymmetricMethod.key; }
            set
            {
                if (SymmetricMethod.key != value)
                {
                    SymmetricMethod.key = value;
                    SymmetricMethod.legalKey = null;
                    SymmetricMethod.legalIV = null;
                }
            }
        }
        private static Encoding encoding;

        public static Encoding Encoding
        {
            get { return SymmetricMethod.encoding; }
            set
            {
                if (SymmetricMethod.encoding != value)
                {
                    SymmetricMethod.encoding = value;
                    SymmetricMethod.legalKey = null;
                    SymmetricMethod.legalIV = null;
                }
            }
        }
        /// <summary>
        /// 对称加密类的构造函数
        /// </summary>

        private static byte[] legalKey;

        public static byte[] LegalKey
        {
            get { return SymmetricMethod.legalKey = SymmetricMethod.legalKey ?? GetLegalKey(); }
        }

        private static byte[] legalIV;

        public static byte[] LegalIV
        {
            get { return SymmetricMethod.legalIV = SymmetricMethod.legalIV ?? GetLegalIV(); }
        }
        /// <summary>
        /// 获得密钥
        /// </summary>
        /// <returns>密钥</returns>
        private static byte[] GetLegalKey()
        {
            string sTemp = key;
            mobjCryptoService.GenerateKey();
            byte[] bytTemp = mobjCryptoService.Key;
            int KeyLength = bytTemp.Length;
            if (sTemp.Length > KeyLength)
                sTemp = sTemp.Substring(0, KeyLength);
            else if (sTemp.Length < KeyLength)
                sTemp = sTemp.PadRight(KeyLength, ' ');
            return SymmetricMethod.encoding.GetBytes(sTemp);
        }
        /// <summary>
        /// 获得初始向量IV
        /// </summary>
        /// <returns>初试向量IV</returns>
        private static byte[] GetLegalIV()
        {
            string sTemp = key;
            mobjCryptoService.GenerateIV();
            byte[] bytTemp = mobjCryptoService.IV;
            int IVLength = bytTemp.Length;
            if (sTemp.Length > IVLength)
                sTemp = sTemp.Substring(0, IVLength);
            else if (sTemp.Length < IVLength)
                sTemp = sTemp.PadRight(IVLength, ' ');
            return SymmetricMethod.encoding.GetBytes(sTemp);
        }
        /// <summary>
        /// 加密方法
        /// </summary>
        /// <param name="source">待加密的串</param>
        /// <returns>经过加密的串</returns>
        public static string Encrypto(string source)
        {
            byte[] bytIn = UTF8Encoding.UTF8.GetBytes(source);
            MemoryStream ms = new MemoryStream();
            mobjCryptoService.Key = LegalKey;
            mobjCryptoService.IV = LegalIV;
            ICryptoTransform encrypto = mobjCryptoService.CreateEncryptor();
            CryptoStream cs = new CryptoStream(ms, encrypto, CryptoStreamMode.Write);
            cs.Write(bytIn, 0, bytIn.Length);
            cs.FlushFinalBlock();
            ms.Close();
            byte[] bytOut = ms.ToArray();
            return Convert.ToBase64String(bytOut);
        }
        /// <summary>
        /// 解密方法
        /// </summary>
        /// <param name="Source">待解密的串</param>
        /// <returns>经过解密的串</returns>
        public static string Decrypto(string Source)
        {
            byte[] bytIn = Convert.FromBase64String(Source);
            MemoryStream ms = new MemoryStream(bytIn, 0, bytIn.Length);
            mobjCryptoService.Key = LegalKey;
            mobjCryptoService.IV = LegalIV;
            ICryptoTransform encrypto = mobjCryptoService.CreateDecryptor();
            CryptoStream cs = new CryptoStream(ms, encrypto, CryptoStreamMode.Read);
            StreamReader sr = new StreamReader(cs);
            return sr.ReadToEnd();
        }
    }
}
