﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Convertor.Interface;
using Wpf.CommonTools.StaticExtension;

namespace Convertor.Plugin.Filter
{
    /// <summary>
    /// ConfigForm.xaml 的交互逻辑
    /// </summary>
    public partial class ConfigForm : PluginConfigForm
    {
        public ConfigForm()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded_1(object sender, RoutedEventArgs e)
        {
        }

        private void tbFilter_MouseDoubleClick_1(object sender, MouseButtonEventArgs e)
        {
            ((TextBox)sender).ShowDropList(InputHistory);
        }

        private void CheckBox_Checked_1(object sender, RoutedEventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            RegexOptions f = (RegexOptions)cb.Tag;
            config.RegexOption = config.RegexOption | f;
        }

        private void CheckBox_Unchecked_1(object sender, RoutedEventArgs e)
        {
            CheckBox cb = (CheckBox)sender;
            RegexOptions f = (RegexOptions)cb.Tag;
            config.RegexOption = (config.RegexOption | f) ^ f;
        }

        #region IConfigFormEvent 成员

        public override object GetConfig()
        {
            return ((ConfigContent)Config).Clone();
        }

        #endregion

        #region IPluginConfig 成员

        private ConfigContent config;
        public override object Config
        {
            get { return config ?? new ConfigContent(); }
            set { config = (value as ConfigContent) == null ? new ConfigContent() : (ConfigContent)((ICloneable)value).Clone(); }
        }

        #endregion

        #region IPluginHistory 成员

        public override object Input { get; protected set; }

        #endregion

    }
}
