﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Convertor.Interface;
using Convertor.Plugin.Combin;

namespace Convertor.Plugin.ReadFromDisk
{
    /// <summary>
    /// ConfigForm.xaml 的交互逻辑
    /// </summary>
    public partial class ConfigForm : PluginConfigForm
    {
        public ConfigForm()
        {
            InitializeComponent();
        }

        private void UserControl_Loaded_1(object sender, RoutedEventArgs e)
        {
            bindEncoding();
            //ConfigContent config = (Config as ConfigContent) ?? new ConfigContent();
            //cbEncodings.SelectedItem = config.FileEncoding;
        }

        private void bindEncoding()
        {
            var b = new Encoding[] { Encoding.Default };
            var a = b.Union(Encoding.GetEncodings().Select(p => p.GetEncoding())).OrderBy(p => p.EncodingName);
            cbEncodings.ItemsSource = a;
        }

        #region IPluginConfig 成员

        private ConfigContent config;
        public override object Config
        {
            get { return config ?? new ConfigContent(); }
            set { config = (value as ConfigContent) == null ? new ConfigContent() : (ConfigContent)((ICloneable)value).Clone(); }
        }

        #endregion

        #region IConfigFormEvent 成员

        public override object GetConfig()
        {
            return ((ConfigContent)Config).Clone();
        }

        #endregion

        #region IPluginHistory 成员

        public override object Input { get; protected set; }

        #endregion
    }
}
