﻿using System.ComponentModel;

namespace Convertor
{
    /// <summary>
    /// Current template model
    /// </summary>
    public class TemplateViewModel : INotifyPropertyChanged
    {
        private TemplateToSaveContainer container;
        /// <summary>
        /// Get or set current Template for saving serialization content
        /// </summary>
        public TemplateToSaveContainer Container
        {
            get { return container ?? (container = new TemplateToSaveContainer()); }
            set { container = value; if (PropertyChanged != null) { PropertyChanged(this, new PropertyChangedEventArgs("Container")); } }
        }

        #region INotifyPropertyChanged 成员

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

    }
}
