﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Data;

namespace Wpf.CommonTools.Converter
{
    public class EnumFlagToVsibleConverter : IValueConverter
    {
        #region IValueConverter 成员

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (DesignerProperties.GetIsInDesignMode(new DependencyObject()))
            {
                return Visibility.Visible;
            }
            else
                if (value == null || parameter == null)
                {
                    return Visibility.Collapsed;
                }
                else
                {
                    return (System.Convert.ToInt32(value) & System.Convert.ToInt32(parameter)) != 0
                        ? Visibility.Visible
                        : Visibility.Collapsed;
                }
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
